/*
 *  $Id: StringFinder.java 324 2009-11-16 17:07:40Z martinlaz $
 *
 *  Author:
 *     Martin Lazarov [mlazarov at sfs.uni-tuebingen.de]
 *     
 *  This file is part of the Gralej system
 *     http://code.google.com/p/gralej/
 *
 *  Gralej is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Gralej is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package gralej.blocks.finder;

import gralej.blocks.Label;

/**
 *
 * @author Martin
 */
class StringFinder extends Finder {    
    StringFinder(FinderOptions opts) {
        super(opts);
    }

    @Override
    protected boolean matches(Label label) {
        String s = label.getText().toLowerCase();
        if (_opts.isCompleteMatch)
            return _opts.text.equals(s);
        return s.indexOf(_opts.text) != -1;
    }

}
