/*  $Id$

    This file is part of the

    GRammar vISUalization tool (GRISU)

    Developed by Holger Wunsch and Detmar Meurers
    Copyright (C) 1998-2005 by the developers
    All rights reserved

    Seminar fr Sprachwissenschaft, Universitt Tbingen and
    Department of Linguistics, The Ohio State University

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @file

   This file contains all version information strings.

   @author Holger Wunsch */


#ifndef __CONFIG_H_
#define __CONFIG_H_

#include <qglobal.h>
#include <kapplication.h>

/* Grisu only runs on KDE 3.x / QT 3.x */
#if QT_VERSION < 0x030000
#error "Qt 3.0 or higher is required to compile Grisu."
#endif

#if KDE_VERSION_MAJOR < 3
#error "KDE 3.0 or higher is required to compile Grisu."
#endif

/** The current version. */
#define GRISU_VERSION "1.4.8"

/** The application name, shown on the title bar of the main window. */
#define APP_NAME "Grisu"


/**
 * The developers.
 */
#define DEVELOPERS "Developed by Holger Wunsch and Detmar Meurers"


/**
 * The Copyright string.
 */
#define COPYRIGHT "Copyright (C) 1998-2005 by the developers"


/** The about string.
    It is formatted as a QT richtext string. */
#define GRISU_ABOUT_STRING \
  "<qt>GRammar vISUalization tool (GRISU)<br><br>"\
  "Version " GRISU_VERSION "<br><br>"\
  DEVELOPERS "<br>"\
  COPYRIGHT "<br>"\
  "All rights reserved<br><br>"\
  "Seminar fr Sprachwissenschaft, Universitt Tbingen and<br>"\
  "Department of Linguistics, The Ohio State University</qt>"

#endif
