/*  $Id$

    This file is part of the

    GRammar vISUalization tool (GRISU)

    Developed by Holger Wunsch and Detmar Meurers
    Copyright (C) 1998-2005 by the developers
    All rights reserved

    Seminar fr Sprachwissenschaft, Universitt Tbingen and
    Department of Linguistics, The Ohio State University

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/** @file

    Implementation of class <code>GDataViewer</code>.

    @author Holger Wunsch */


#include "gdataviewer.h"
#include "gdataholder.h"

#include "gdataviewer.moc"


/** Creates a new instance of this class.
    @param holder the <code>GDataHolder</code> instance that should be notified when
    this viewer is closed.
    @param parent the parent widget.
    @param name the name of the widget */
GDataViewer::GDataViewer(GDataHolder* holder, QWidget* parent, const char* name):
  KMainWindow(parent, name) {
  this->holder = holder;
}


/** Closes this viewer and notifies the holder.
      
    @param ce the event class */
void GDataViewer::closeEvent(QCloseEvent* ce) {
  KMainWindow::closeEvent(ce);
  holder->viewerClosed(this);
}
