%% RCS: $Id: sics.pl,v 1.35 1999/02/06 16:48:59 gpenn Exp $
% $Log: sics.pl,v $

% Revision 1.36  2003/12/31  19:54:19  gpenn
% switched character_escapes on for consistency with ale.pl and TGC

% Revision 1.35  1999/02/06  16:48:59  gpenn
% added is_upper/1 to export list for TRALE's new sig-file parser.
%
% Revision 1.34  1998/10/14  18:49:52  gpenn
% Changed save_program/1 to save_program/2 for SICStus 3.7.1
%
% Revision 1.33  1998/09/07  23:53:26  gpenn
% Changed save/2 to save_program/1 for SICStus 3.7
%
% Revision 1.32  1998/03/24  21:29:16  gpenn
% SWI port - statistics/2 is platform-dependent.  Added t_cputime/1.
%
% Revision 1.31  1997/12/11  19:41:27  gpenn
% added t_print_message/2
%
% Revision 1.30  1997/12/03  15:59:46  gpenn
% SWI port: added ord_union/2, ord_del_element/3, ord_subtract/3,
%  ord_intersect/2, and ord_intersection/2.
%
% Revision 1.29  1997/12/02  15:50:40  gpenn
% Changed site_import/1 to site_import/2 to handle modules.
%
% Revision 1.28  1997/12/01  22:35:18  dm
% added comment to t_absolute_file_name pointing out the differences
% between the quintus and sicstus versions
%
% Revision 1.27  1997/12/01  20:43:15  dm
% Predicate remove_dups/2 now is defined as sort/2 to be compatible with
% the quintus!
%
% Revision 1.26  1997/12/01  13:11:05  gpenn
% SWI port: assoc lists are platform-dependent.
%
% Revision 1.25  1997/12/01  11:15:06  gpenn
% Created site_import/1 to hack around startup script.
%
% Revision 1.24  1997/11/30  21:35:25  gpenn
% SWI port: added ord_subset/2,ord_intersection/3,ord_add_element/3,
% and ord_union/3.
%
% Revision 1.23  1997/11/25  20:56:24  gpenn
% SWI port: changed select/3 to t_select/3
%
% Revision 1.22  1997/08/02  18:59:54  dm
% Changed it so that the file only contains the basic loading and saving
% operations of states in basic_save_state/1 and basic_load_state/1. The
% rest is now done for all prologs in ctroll.pl
%
% Revision 1.21  1997/08/02  18:46:09  dm
% - removed load_state_or_file/3, which is no longer used
% - changed save_state/2 and load_state/1 to use add_state_suffix/2
%   defined in ctroll.pl
%
% Revision 1.20  1997/07/28  19:01:53  dm
% added name of operating system to state name
%
% Revision 1.19  1997/07/24  11:43:51  dm
% *** empty log message ***
%
% Revision 1.18  1997/07/24  11:43:34  dm
% fixed minor bug in t_working_directory/1
%
% Revision 1.17  1997/07/18  13:32:16  dm
% fixed bug in t_abolish/1
%
% Revision 1.16  1997/07/17  23:17:59  dm
% Added t_abolish/1 to avoid the warning messages which sicstus outputs
% if one abolishes an undefined predicate.
%
% Revision 1.15  1997/07/17  21:48:10  dm
% worked over the load_state stuff
%
% Revision 1.14  1997/07/17  20:27:08  dm
% added load_state_or_file/2 and save_state/2
%
% Revision 1.13  1997/07/17  20:03:38  dm
% use save/1 instead of save_program to be able to specify a
% continuation after restore
%
% Revision 1.12  1997/07/17  19:57:37  dm
% *** empty log message ***
%
% Revision 1.11  1997/07/17  17:01:55  dm
% - fixed definition of t_no_style_check(all), where a . instead of a ,
%   caused a redefinition error for prolog_flag/3
% - added environ/3
% - changed t_working_directory to refer to the variable STARTUP_DIR,
%   which needs to be set in the script which starts up Controll
%
% Revision 1.10  1997/07/17  11:32:09  dm
% added save_state/1 and load_state/1 to module declaration
%
% Revision 1.9  1997/07/17  11:11:05  dm
% parametrized state stuff, so that we now have save_state/1 and load_state/1
%
% Revision 1.8  1997/07/17  11:08:41  dm
% Added save_state/0 and load_state/0.
%
% Revision 1.7  1997/06/16  09:13:22  dm
% added reverse/2 to export from site
%

% Predicates to export to other module files:
% Because some of these are used in module files (e.g. objects/options.pl),
% we can't just move their library links
% up to the port patches.  And we can't use the module-expanded predicate
% names because the names are different across Prolog platforms.  We 
% need a site module too.

:- module(site,[is_list/1,reverse/2,remove_dups/2,
    t_style_check/1,t_no_style_check/1,t_open/3,t_write/2,
    t_working_directory/1,concat_atom/2,file_exists/1,
    t_absolute_file_name/3,directory_exists/1,t_write/1,t_see/1,
    t_read_term/2,t_tell/1,file_must_exist/1,concat/3,is_lower/1,is_alnum/1,
    samsort/2,p_vertices/2,p_transpose/2,warshall/2,t_abolish/1,
    s_transpose/2,getpid/1,t_reconsult/1,unix/1,ord_intersect/3,
    t_samsort/3,string_append/3,t_div/3,p_to_s_graph/2,s_to_p_graph/2,
    write_backslash/0,fail_if_undefined/1,get_line/1,
    print_length/2,gensym/2,t_select/3,close_all_streams/0,
    basic_save_state/2,basic_load_state/1,environ/2,ord_subset/2,
    ord_add_element/3,ord_union/3,ord_intersection/3,site_import/2,
    get_assoc/3,put_assoc/4,ord_union/2,ord_del_element/3,ord_subtract/3,
    ord_intersect/2,ord_intersection/2,t_print_message/2,t_cputime/1,
    is_upper/1,t_send_little_dot_command/1,t_send_big_dot_command/3,system/1,
    delete_file/2,tell_tmpnam_dot/2,told_tmpnam_dot/1]).

:- use_module(library(lists),[is_list/1,max_member/2,
              nth1/3,reverse/2,same_length/2,remove_dups/2,
              select/3]).
:- use_module(library(process),[process_id/1,process_create/3,process_wait/2]).
:- use_module(library(file_systems),[file_exists/1,file_must_exist/1,delete_file/1]).
:- use_module(library(ordsets),[ord_intersection/3,ord_subset/2,
                                ord_add_element/3,ord_union/3,ord_union/2,
                                ord_del_element/3,ord_subtract/3,
                                ord_intersect/2,ord_intersection/2]).
:- use_module(library(system),[environ/2]).
:- use_module(library(assoc),[get_assoc/3,put_assoc/4]).

%%% no transpose/2

transpose([],[]).
transpose([Xs|XsRest],Yss) :-
  transpose_act(XsRest,Xs,Yss).

transpose_act([],Xs,Yss) :-
  !,transpose_one(Xs,Yss).
transpose_act(XsRest,Xs,Yss) :-
  transpose_many(Xs,Yss,XsRest,YsRest,YsRest).

transpose_one([],[]).
transpose_one([X|Xs],[[X]|Yss]) :-
  transpose_one(Xs,Yss).

transpose_many([],[],XsRest,YsRest,[]) :-
  transpose(XsRest,YsRest).
transpose_many([X|Xs],[[X|Ys]|Yss],XsRest,YsRest,[Ys|YsRestDiff]) :-
  transpose_many(Xs,Yss,XsRest,YsRest,YsRestDiff).

%%% no line IO routines

get_line(Chars) :-
  current_input(Stream),
  \+ at_end_of_stream(Stream),  % quietly fail if EOF
  on_exception(get_line_eof,get_line_act(Chars,Stream),fail).  % ditto

get_line_act(Chars,Stream) :-
  at_end_of_line(Stream) -> (Chars = [],
                             skip_line(Stream))
                          ; (get0(Stream,C),
                             ((C == -1) -> raise_exception(get_line_eof)
                                         ; (Chars = [C|Rest],
                                            get_line_act(Rest,Stream))
                             )
                            ).

%%% max_list/2 has a different name in SP4

max_list(A,B) :-
  max_member(A,B).

%%% no print_length/2 in SICStus

:- ensure_loaded('sicstus_additions/printlength.pl').  % plagiarised from O'Keefe

%%% nth/3 has a different name in SP4

nth(A,B,C) :-
  nth1(A,B,C).

%%% remove_dups/2 in quintus is implemented by sort
%%% so we here use sort too. 
%%% NOTE: remove_dups/2 thus differes from remove_duplicates/2 
%%% defined in the sicstus list library, which does not order the elements.

% SP4: remove_dups/2 is available from library(lists)
%remove_dups(A,B) :-
%  sort(A,B).

%%% no samsort/2 or samsort/3 in SICStus (SICStus has a sort, but not one that
%%%  doesn't merge (w/o keys), or generalizes over comparison operators).

:- ensure_loaded('sicstus_additions/samsort.pl').  % plagiarised from O'Keefe

t_samsort(X,Y,Z) :-   % patch code in samsort.pl adds module name (user)
  samsort(X,Y,Z).

:- meta_predicate fail_if_undefined(:).
fail_if_undefined(Goal) :-
  on_exception(error(existence_error(_,_),existence_error(_,_,_,_,_)),Goal,fail).
  % SP4: new syntax for exceptions

% special hack for sicstus needed to avoid warnings
% for abolish on undefined predicates
t_abolish(Goal/Arity) :-
	functor(Pred,Goal,Arity),
	(predicate_property(user:Pred,_) ->
	    abolish(user:Goal/Arity)
	;   true).

%%% no p or s graphs in SICStus (can replace with ugraphs library, once I
%%%  figure out how ctroll is building graphs)

:- ensure_loaded('sicstus_additions/graphs.pl').   % plagiarised from O'Keefe

%%% no close_all_streams/0 in SICStus

close_all_streams :-
  current_stream(_,_,Stream),
  close(Stream),
  fail.
close_all_streams.

% no maplist/2 or maplist/3

maplist(Pred,List) :-
  maplist_act(List,Pred).

maplist_act([],_).
maplist_act([X|Xs],Pred) :-
  Goal =.. [Pred,X],
  call(Goal),
  maplist_act(Xs,Pred).

maplist(Pred,Olds,News) :-
  maplist_act(Olds,News,Pred).

maplist_act([],[],_).
maplist_act([O|Os],[N|Ns],Pred) :-
  Goal =.. [Pred,O,N],
  call(Goal),
  maplist_act(Os,Ns,Pred).

% no lower/2 or upper/2

:- ensure_loaded('sicstus_additions/case_conv.pl').   % plagiarised from O'Keefe

% no flatten/2

flatten(Tree,List) :-
  flatten_act(Tree,List,[]).

flatten_act([],List,List) :- !.
flatten_act([Head|Tail],List,Rest) :-
  !,flatten_act(Head,List,RestHead),
  flatten_act(Tail,RestHead,Rest).
flatten_act(Other,[Other|Rest],Rest).

% no concat_atom/2

concat_atom(Consts,Atom) :-
  nonvar(Consts) -> concat_atom_act(Consts,Codes,[]),
                    flatten(Codes,AtomCode),
                    name(Atom,AtomCode)
 ;raise_exception(instantiation_error(concat_atom(Consts,Atom),1)).

% fail quietly on non-lists
concat_atom_act([],Codes,Codes).
concat_atom_act([Const|Consts],Codes,Rest) :-
  (atomic(Const) -> name(Const,ConstCodes),
                    append(ConstCodes,CodesRest,Codes)
                 ;is_list(Const),  % fail quietly on non-list compound members
                  append(Const,CodesRest,Codes)), % assume char. codes - name/2
                                            % in concat_atom/2 will flag errors
  concat_atom_act(Consts,CodesRest,Rest).

% ord_intersect/3 is really ord_intersection/3 (even in Quintus)
ord_intersect(A,B,C) :-
  ord_intersection(A,B,C).

% Quintus div/2 is '//'/2

t_div(Quotient,Dividend,Divisor) :-
   Quotient is Dividend // Divisor.

% no gensym/2

:- ensure_loaded('sicstus_additions/strings.pl').  % plagiarized from O'Keefe

% unix/1 shell fork

unix(system(SystemCall)) :-
  system(SystemCall,[]).

system(SystemCall) :- system(SystemCall,[]).
system(SystemCall,Options) :-
  absolute_file_name('$SHELL',S),
  process_create(S,['-c',SystemCall],Options).

% SP4: delete_file/2 is gone, but we seem only to need the ignore flag
delete_file(File,Options) :-
  Options = [ignore] -> on_exception(error(_,_),  % HACK: maybe should not throw all errors away
                                     delete_file(File),
                                     true)
  ; raise_exception(ale(unsupported(delete_file/2))).


%%% This is just used by the type hierarchy compiler - built-in in SICStus

getpid(PID) :-
  process_id(PID).

% style_check is done differently in SICStus, and it has no
%   discontiguous style_check

t_style_check(multiple) :-
        prolog_flag(redefine_warnings,_,on).
t_style_check(single_var) :-
        prolog_flag(single_var_warnings,_,on).
t_style_check(discontiguous).   % no discontiguous style checking in SICStus
%        print_message(warning,troll_no_style_warning(discontiguous)).
t_style_check(all) :-
        prolog_flag(redefine_warnings,_,on),
        prolog_flag(single_var_warnings,_,on).
%        print_message(warning,troll_no_style_warning(discontiguous)).
t_style_check(X) :-
        var(X),
        !,fail.
t_style_check(X) :-   
        raise_exception(domain_error(t_style_check(X),1,
                        {multiple,single_var,discontiguous,all},X)).

t_no_style_check(multiple) :-
	prolog_flag(redefine_warnings,_,off).
t_no_style_check(single_var) :-
        prolog_flag(single_var_warnings,_,off).
t_no_style_check(discontiguous).  % no discontiguous style checking in SICStus
t_no_style_check(all) :-
        prolog_flag(redefine_warnings,_,off),
        prolog_flag(single_var_warnings,_,off).

% SWI doesn't handle print_message/2 in full generality

t_print_message(K,T) :-
  print_message(K,T).

% SWI does not handle the PATH(FILE) notation in see/1 and tell/1.

t_tell(X) :-
	tell(X).
t_see(X) :-
	see(X).
t_open(X,Y,Z) :-
	open(X,Y,Z).

% SWI write/1 and write/2 don't know about '$VAR'(Int) syntax

t_write(X) :-
	write(X).
t_write(X,Y) :-
	write(X,Y).

% SICStus absolute_file_name takes no options
% NOTE: THIS MEANS IT WILL HAVE A DIFFERENT BEHAVIOUR THAN THE QUINTUS
% VERSION IF A FILE PLUS .pl EXTENSION AND ONE WITHOUT THE SIMPLE 
% FILENAME EXISTS. Qunitus with [file_type(text)] will then return
% the name without the suffix, while Sicstus returns the one with it. 

t_absolute_file_name(A,_B,C) :-
%        (B = [],!
%        ; print_message(warning,troll_no_absolute_options_warning(B))),
	absolute_file_name(A,C).

% SICStus options for read_term/2 are different

t_read_term(X,Y) :-
	read_term(Y,X).

% For SICStus, \ is an escape character - turn character escapes off

%:- prolog_flag(character_escapes,_,off).
write_backslash :-
	write('\\').     % '  <-- I hate emacs-font-highlighting!


% t_working_directory/1 to get the directory, where prolog was started
% Note: Both Quintus and Sicstus have a predicates dedicated for a similar
% purpose. But upon loading code which loads other code, both tempo-
% rarily return the directory where the code is loaded from!
% Sicstus in addition also does a cd to the directory where a file
% is loaded from, so that even a unix system call won't provide us
% with the original starting directory.
%
% The predicate below therefore assumes that the environment variable
% STARTUP_DIR has been set upon startup

t_working_directory(WD) :-
	   (environ('STARTUP_DIR',WD) ->
	       true
	   ;
	       format(user_output,' * Internal error: STARTUP_DIR not set in environment.~n',[])).


% SWI puts Elt second
t_select(Elt,List,Residue) :-
  select(Elt,List,Residue).  % from library(lists)

% You shouldn't use the predicate name rename_file/2, this is a
% built-in in SWI

rename_file(X,Y) :-
	append_pl(X,Y).

%%% no string_append/3 or concat/3 in SICStus
%%% THE BIG LIE:  these Quintus predicates only work for atoms; their 
%%%  advertised support for Lisp strings has not been implemented in the
%%%  Quintus library.  Of course, I follow suit here for compatibility. :-)

concat(A,B,C) :-
  atomic(B),     % numbers are allowed - check to cause failure (vs. exception)
  ( atom(A) -> name(B,BList), % name will check nonvar status of B
               name(A,AList),
               append(AList,BList,CList),
               name(C,CList)
             ;(atom(C),       % concat fails instead of raising instant. error
               name(B,BList), % name will check nonvar status of B
               name(C,CList),
               append(AList,BList,CList),
               name(A,AList))
  ).
   
string_append(A,B,C) :-
  var(C) -> atom_chars(A,AList),
            atom_chars(B,BList),
            append(AList,BList,CList),
            atom_chars(C,CList)
          ; (var(B) -> atom_chars(A,AList),
                       atom_chars(C,CList),
                       append(AList,BList,CList),
                       atom_chars(B,BList)
                     ; % var(A),
                       atom_chars(B,BList),
                       atom_chars(C,CList),
                       append(AList,BList,CList),
                       atom_chars(A,AList)
            ).

%%% In Quintus, reconsulting a file loads its predicates into the user
%%%  module.  In SICStus, reconsulting a file loads its predicates into the
%%%  current module.  t_reconsult/1 loads a file's predicates into the user
%%%  module in both prologs.

t_reconsult(F) :-
  compile(user:F).  % in SICStus, consult is not the same as compile!!!

% t_cputime measures CPU time elapsed since prolog session was started in ms.

t_cputime(SinceStart) :- 
  statistics(runtime,[SinceStart|_]).

%% basic loading and saving of program states

% basic_save_state/2 expects 
% - an absolute filename as first argument
% - a goal to execute as second argument

% SICStus 3.7 threw out save/2. :-(  Now we have to pass the startup goal on
%  the command line.
basic_save_state(F,G) :-
	save_program(F,user:G).
%	user:G.

% basic_load_state/1 expects 
% - an absolute filename as argument

basic_load_state(F) :-
	restore(F).

site_import(M,ImportList) :-
  M:use_module(site,troll_home(sics),ImportList).

%==============================================================================

%%% no is_lower/1 or is_alnum/1 in SICStus

is_lower(97).  is_lower(98).  is_lower(99).  is_lower(100).
is_lower(101).  is_lower(102).  is_lower(103).  is_lower(104).
is_lower(105).  is_lower(106).  is_lower(107).  is_lower(108).
is_lower(109).  is_lower(110).  is_lower(111).  is_lower(112).
is_lower(113).  is_lower(114).  is_lower(115).  is_lower(116).
is_lower(117).  is_lower(118).  is_lower(119).  is_lower(120).
is_lower(121).  is_lower(122).  is_lower(224).  is_lower(225).
is_lower(226).  is_lower(227).  is_lower(228).  is_lower(229).
is_lower(230).  is_lower(231).  is_lower(232).  is_lower(233).
is_lower(234).  is_lower(235).  is_lower(236).  is_lower(237).
is_lower(238).  is_lower(239).  is_lower(240).  is_lower(241).
is_lower(242).  is_lower(243).  is_lower(244).  is_lower(245).
is_lower(246).  is_lower(247).  is_lower(248).  is_lower(249).
is_lower(250).  is_lower(251).  is_lower(252).  is_lower(253).
is_lower(254).

is_alnum(48).  is_alnum(49).  is_alnum(50).  is_alnum(51).
is_alnum(52).  is_alnum(53).  is_alnum(54).  is_alnum(55).
is_alnum(56).  is_alnum(57).  is_alnum(65).  is_alnum(66).
is_alnum(67).  is_alnum(68).  is_alnum(69).  is_alnum(70).
is_alnum(71).  is_alnum(72).  is_alnum(73).  is_alnum(74).
is_alnum(75).  is_alnum(76).  is_alnum(77).  is_alnum(78).
is_alnum(79).  is_alnum(80).  is_alnum(81).  is_alnum(82).
is_alnum(83).  is_alnum(84).  is_alnum(85).  is_alnum(86).
is_alnum(87).  is_alnum(88).  is_alnum(89).  is_alnum(90).
is_alnum(97).  is_alnum(98).  is_alnum(99).  is_alnum(100).
is_alnum(101).  is_alnum(102).  is_alnum(103).  is_alnum(104).
is_alnum(105).  is_alnum(106).  is_alnum(107).  is_alnum(108).
is_alnum(109).  is_alnum(110).  is_alnum(111).  is_alnum(112).
is_alnum(113).  is_alnum(114).  is_alnum(115).  is_alnum(116).
is_alnum(117).  is_alnum(118).  is_alnum(119).  is_alnum(120).
is_alnum(121).  is_alnum(122).  is_alnum(192).  is_alnum(193).
is_alnum(194).  is_alnum(195).  is_alnum(196).  is_alnum(197).
is_alnum(198).  is_alnum(199).  is_alnum(200).  is_alnum(201).
is_alnum(202).  is_alnum(203).  is_alnum(204).  is_alnum(205).
is_alnum(206).  is_alnum(207).  is_alnum(208).  is_alnum(209).
is_alnum(210).  is_alnum(211).  is_alnum(212).  is_alnum(213).
is_alnum(214).  is_alnum(215).  is_alnum(216).  is_alnum(217).
is_alnum(218).  is_alnum(219).  is_alnum(220).  is_alnum(221).
is_alnum(222).  is_alnum(223).  is_alnum(224).  is_alnum(225).
is_alnum(226).  is_alnum(227).  is_alnum(228).  is_alnum(229).
is_alnum(230).  is_alnum(231).  is_alnum(232).  is_alnum(233).
is_alnum(234).  is_alnum(235).  is_alnum(236).  is_alnum(237).
is_alnum(238).  is_alnum(239).  is_alnum(240).  is_alnum(241).
is_alnum(242).  is_alnum(243).  is_alnum(244).  is_alnum(245).
is_alnum(246).  is_alnum(247).  is_alnum(248).  is_alnum(249).
is_alnum(250).  is_alnum(251).  is_alnum(252).  is_alnum(253).
is_alnum(254).  is_alnum(255).

%==============================================================================
%Hooks for SICStus Prolog 4 port

t_send_little_dot_command(FileName) :-
  atom_concat(FileName,'.dot',DotName),
  atom_concat(FileName,'.svg',SvgName),
  open(SvgName,write,SvgStream),
  system([dot,'-Tsvg',file(DotName)],[stdout(pipe(SvgStream))]),
  close(SvgStream).

t_send_big_dot_command(Format,Program,FileName) :-
  atom_concat('.',Format,DottedFormat),
  atom_concat('-T',Format,FormatFlag),
  atom_concat(FileName,'.dot',DotName),
  atom_concat(FileName,DottedFormat,FormattedName),
  format_to_codes('dot -T~w ~w.dot > ~w.~w;~w ~w.~w&',[Format,Filename,Filename,Format,Program,Filename,Format],String),
  atom_codes(Command,String),
  format('~N~p~n',[Command]), % tell user what we're doing
  open(FormattedName,write,FormattedStream),
  system([dot,FormatFlag,file(DotName)],[stdout(pipe(FormattedStream)),process(ProcRef)]),
  process_wait(ProcRef,exit(0)),
  flush_output(FormattedStream), close(FormattedStream),
  system([file(Program),file(FormattedName)],[detached(true)]).

tell_tmpnam_dot(FileName,S) :-
  current_output(S),
  open('viz.dot',write,DotStream,[if_exists(generate_unique_name)]),
  stream_property(DotStream,file_name(DotName)),
  name(DotName,DotChars),
  append(FileChars,".dot",DotChars),
  name(FileName,FileChars),
  set_output(DotStream).

told_tmpnam_dot(S) :-
  current_output(DotStream),
  set_output(S),
  close(DotStream).

