:- dynamic trale_host/1.

detect_host :-
    retractall(trale_host(_)),
    (   current_prolog_flag(dialect, swi)
    ->  assert(trale_host(swi))
    ;   current_prolog_flag(version, Version),
        atom(Version)
    ->  (   atom_concat('SICStus 3.', _, Version)
        ->  assert(trale_host(sics)),
            assert(trale_host(sics3))
        ;   atom_concat('SICStus 4.', _, Version)
        ->  assert(trale_host(sics)),
            assert(trale_host(sics4))
        )
    ), !.
detect_host :-
    write(failed(detect_host)), nl,
    abort.

require_host(Host) :-
    trale_host(Host) -> true
    ;   write(failed(require_host(Host))), nl,
        abort.

if_host(Host, Goal, ElseGoal) :-
    trale_host(Host) -> call(Goal)
    ;   call(ElseGoal).

if_host(Host, Goal) :-
    if_host(Host, Goal, true).

:-  detect_host,
    (   trale_host(Host),
        atom_concat('trale_host_', Host, TraleHostPl),
        ensure_loaded(TraleHostPl),
        fail
    ;   true
    ).
