%%% $Id: trale_patches.pl,v 1.32 2005/02/13 10:33:00 stefan Exp $
%
% Hook predicates defined in trale.pl or ale.pl for the GUI
%
% -----------------------------------------------------------------

% GBP - cleaned this file up by using a more principled set of hooks.

:- multifile compile_sig_hook/0.
compile_sig_hook :-
  compute_feature_ordering,
  process_feature_output.  % GBP - for lex/1 etc. until we cut the old GUI loose

:- multifile abolish_user_preds/1.
:- dynamic grale_forall_hook_loaded/0.
abolish_user_preds(sig) :-  
  abolish_feature_ordering,
  abolish_gramint_preds.    % GBP - this was being implemented as an 'all' abolish
                            %  before, but it looks like a 'sig' abolish, too.
abolish_user_preds(grammar) :-
  retractall(grale_forall_hook_loaded).
%  reconsult(trale_home(grale_forall)).
abolish_user_preds(all) :-
  abolish_gramint_preds,
  retractall(grale_forall_hook_loaded).
%  reconsult(trale_home(grale_forall)).

% GBP - We need to keep this stuff around until lex/1 and the other top-level preds migrate
%   to the new GUI.
abolish_gramint_preds :-  % GBP - at least, I think this is for grammar_interface.pl
  clear_feature_output,	% initialize feature_ordering.pl preds
  abolish(dtrs_feat/1),
  abolish(phon_feat/1),
  abolish(list_type/1),
  abolish(ne_list_type/1),
  abolish(hd_feat/1),
  abolish(tl_feat/1).

:- multifile clear_hook/0.
clear_hook :- retractall(grale_psrule_varlink(_,_,_)).

:- multifile user:term_expansion/2.
term_expansion((LHS rule RHS),(LHS rule RHS)) :-
  clause(grale_forall_hook_loaded,true) -> true
  ; reconsult(trale_home(grale_forall)),
    assert(grale_forall_hook_loaded).
term_expansion(((LHS rule RHS) :- Body),((LHS rule RHS) :- Body)) :-
  clause(grale_forall_hook_loaded,true) -> true
  ; reconsult(trale_home(grale_forall)),
    assert(grale_forall_hook_loaded).
