:- use_module(library(ugraphs), [neighbors/3]).
:- use_module(library(ordsets), [ord_union/4]).

% copied from library(ugraphs) of sicstus

%   min_path(+V1, +V2, +Graph, -Path, -Length)
%   is true if Path is a list of vertices constituting a shortest path
%   of length Length from V1 to V2 in Graph.  Takes O(N^2) time.

min_path(Initial, Final, Graph, Path, Length) :-
	min_path__([[Initial]|Q], Q, [Initial], Final, Graph, Rev),
	reverse(Rev, Path),
	length(Path, N),
	Length is N-1.

min_path__(Head0, Tail0, Closed0, Final, Graph, Rev) :-
	Head0 \== Tail0,
	Head0 = [Sofar|Head],
	Sofar = [V|_],
	(   V==Final -> Rev = Sofar
	;   neighbors(V, Graph, Neibs),
	    ord_union(Closed0, Neibs, Closed, Neibs1),
	    enqueue__(Neibs1, Sofar, Tail0, Tail),
	    min_path__(Head, Tail, Closed, Final, Graph, Rev)
	).

enqueue__([], _) --> [].
enqueue__([V|Vs], Sofar) --> [[V|Sofar]], enqueue__(Vs, Sofar).
