% SP4: get_assoc/3 is now avl_fetch/3, put_assoc/4 is now avl_store/4
:- abolish([reverse/2,ord_union/3,avl_fetch/3,
	    avl_store/4,ord_intersect/2,ord_intersection/3,ord_add_element/3,
	    is_list/1,ord_subtract/3],[force(true),tree(true)]).
:- ensure_loaded(sics4).

:- compile(pth4).

% SP4: term_expansion/[2,4] is now term_expansion/6
:- multifile term_expansion/6.
:- discontiguous term_expansion/6.

% cons/2 capture - must map to trale_cons/2 so that compile_deranged can add
%  constraints for exhaustive subtype covering
term_expansion((Type cons Cons),Layout,Ids,trale_cons(Type,Cons),Layout,
          [ale_cons|Ids]) :-  % probably do not need to transform cons/2 layout
  prolog_load_context(file,File),  % SP4: term_expansion/6 is recursive, so make
  \+ clause(ale_compiling(File),true). % it skip the cons/2 clauses we generate

% SP4: remove_duplicates/2 is gone, and it is not the same as remove_dups/2, which is sort/2
% SP4: remove_duplicates/2 is no longer in library(lists)
remove_duplicates([], []).
remove_duplicates([Head|Tail1], [Head|Tail2]) :- 
	delete_sp3(Tail1, Head, Residue),
        remove_duplicates(Residue, Tail2).

% SP4: this is not the delete/3 of library(lists), which uses unification in second clause
%  to match Head and Element
delete_sp3([], _, []).
delete_sp3([Head|Tail], Element, Rest) :-
	Head==Element, !,
	delete_sp3(Tail, Element, Rest).
delete_sp3([Head|Tail], Element, [Head|Rest]) :-
	delete_sp3(Tail, Element, Rest).

:- use_module(library(codesio),[write_to_codes/2]).
