%%% ==================================================================
%%%
%%% Some extensions for using the TRALE system with emacs
%%%
%%% $Id: trale_emacs.pl,v 1.1 2005/06/19 17:19:17 stefan Exp $
%%%
%%% Time-stamp: <stefan on 17.June.2005 19:22:11 EST>
%%%
%%% ==================================================================


no_questions :-
        retractall(ask_questions_flag).

ask_questions :-
        assert(ask_questions_flag).

% This is needed for calls from the interactive mode.
% ALE uses failure driven loops to print information and fails in the end.
wrapped_rule(RuleName) :-
        ( alec_rule(RuleName,_,_,_,_,_) ->
            rule(RuleName)
        ; ( language(german) -> format(user_error,"~n~n* Es gibt keine Regel mit dem Namen `~w'.~n~n",[RuleName])
              ; format(user_error,"~n~n* There is no rule with the name `~w'.~n~n",[RuleName])
          )
        )
        

% please do not fail!
        ; true.


wrapped_macro(MacroName) :-
        no_questions,
        ( (MacroName macro _) -> 
            macro(MacroName)
        ; ( language(german) -> format(user_error,"~n~n* Es gibt kein Makro mit dem Namen `~w'.~n~n",[MacroName])
              ; format(user_error,"~n~n* There is no macro with the name `~w'.~n~n",[MacroName])
          )
        ),
        ask_questions
        ; true.

wrapped_macro(_).


wrapped_show_type(Type) :-
        ( type(Type) ->
            show_type(Type)
        ; ( language(german) -> format(user_error,"~n~n* Es gibt keinen Typ mit dem Namen `~w'.~n~n",[Type])
          ; format(user_error,"~n~n* There is no type with the name `~w'.~n~n",[Type])
          )
        )
        ; true.

wrapped_lex(Word) :-
        no_questions,
        ( current_predicate(lex,lex(_,_))
        ->  (lex(Word,_) ->
                lex(Word)
            ; ( language(german) -> format(user_error,"~n~n* Es gibt keinen Eintrag fr das Wort `~w'.~n~n",[Type])
              ; format(user_error,"~n~n* There is no entry for the word `~w'.~n~n",[Type])
              )
            
            ; raise_exception(ale(no_lex)))
        ),
        ask_questions
        ; true.


show_all_words :-
        (current_predicate(lex,lex(_,_))
               -> (lex(Word,_),
                      write(Word),nl,fail
                  ; number_of(lex(_,_),Number),
                      ( language(german) -> format(user_error,"~n~nInsgesamt ~w Wrter~n~n",[Number])
                      ; format(user_error,"~n~n~w words in total~n~n",[Number])
                      )
                  )
        ; raise_exception(ale(no_lex))).


number_of(Predicate,Number):-
	( current_predicate(_,Predicate) ->
		 findall(_,Predicate,List),
		 length(List,Number)
	; Number is 0
	).