/* 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%   $RCSfile: itsdb.c,v $
%%  $Revision: 1.3 $
%%      $Date: 2006/03/03 17:48:16 $
%%     Author: Stefan Mueller (Stefan.Mueller@uni-bremen.de)
%%    Purpose: communication with [incr TSDB()]++
%%             via capi interface
%%   Language: C
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% $Log: itsdb.c,v $
%% Revision 1.3  2006/03/03 17:48:16  stefan
%% this works with unicode
%%
%% Revision 1.2  2003/07/09 20:33:44  stefan
%% adapted to new protocol
%%
%% Revision 1.1  2003/05/08 21:50:58  stefan
%% *** empty log message ***
%%
%% Revision 1.1  2003/05/04 17:23:20  stefan
%% Initial revision
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>  /* getenv and chars */
#include <sicstus/sicstus.h> 
#include "itsdb.h"


SP_pred_ref create,process,complete; 

int trale_create_run(char *data, int run_id, char *comment, int interactivep, int protocol, char *custom) {
  SP_term_ref term_data, term_run_id, term_comment, term_interactivep, term_protocol, term_custom;
  char *text = NULL;

  /* fprintf(stderr, "Calling Create Run\n"); */


  SP_put_string(term_data   = SP_new_term_ref(), data); 
  SP_put_integer(term_run_id     = SP_new_term_ref(), run_id); 
  SP_put_string(term_comment  = SP_new_term_ref(), comment); 
  SP_put_integer(term_interactivep   = SP_new_term_ref(), interactivep); 
  SP_put_integer(term_protocol   = SP_new_term_ref(), protocol); 
  SP_put_string(term_custom  = SP_new_term_ref(), custom); 

  if (SP_query(create, term_data, term_run_id, term_comment, term_interactivep, term_protocol, term_custom)==SP_SUCCESS) {
    /*    fprintf(stderr, "create succeded: %s\n",text);*/
  } else {
    fprintf(stderr, "create didn't succed\n");
  };
  return 0;
}

int trale_process_item(int i_id, char *i_input, int parse_id, int edges,
                 int nderivations, int derivationp, int interactivep) {

  SP_term_ref term_i_id, term_i_input, term_parse_id, term_edges, term_nderivations, term_derivationp, term_interactivep;
  char *text = NULL;

  /*  fprintf(stderr, "process_item(%s)\n",i_input);  */

  SP_put_integer(term_i_id     = SP_new_term_ref(), i_id); 
  SP_put_string(term_i_input   = SP_new_term_ref(), SP_from_os(i_input,WCX_FILE)); 
  SP_put_integer(term_parse_id = SP_new_term_ref(), parse_id); 
  SP_put_integer(term_edges    = SP_new_term_ref(), edges); 
  SP_put_integer(term_nderivations    = SP_new_term_ref(), nderivations); 
  SP_put_integer(term_derivationp    = SP_new_term_ref(), derivationp); 
  SP_put_integer(term_interactivep   = SP_new_term_ref(), interactivep); 

  /*fprintf(stderr, "Created terms, calling Prolog\n");*/

  if (SP_query(process, term_i_id, term_i_input, term_parse_id, term_edges, term_nderivations, term_derivationp, term_interactivep)==SP_SUCCESS) {

    /* fprintf(stderr, "process succeded: %s\n",text); */
  } else {
    fprintf(stderr, "process didn't succed\n");
  };

/*  fprintf(stderr, "Called Prolog\n");*/

  return 0;
}

int trale_reconstruct_item(char *derivation)
{
  return 0;
}

int trale_complete_run(int run_id, char *custom) {

  return 0;
}

int wcx_capi_printf(char *string) {
  /*   fprintf(stderr,"%s",SP_to_os(string,WCX_FILE)); */
   capi_printf("%s",SP_to_os(string,WCX_FILE));
   return 0;
}

int connect_tsdb(int dummy) {
  SP_qid goal; 
  char *sp_ctype;

  /*  fprintf(tmp, "calling connect_tsdb!\n\n\n\n\n"); */

  sp_ctype = getenv("SP_CTYPE");

  /* If SP_CTYPE is set, configure the OS input/output to be UTF-8 */

  if (sp_ctype) {

    fprintf(stderr, "SP_CTYPE is %s!\n", sp_ctype);


    if (!strcmp( sp_ctype, "utf8")) { 

      SP_set_wcx_hooks(WCX_OS_UTF8,
                       NULL,
                       NULL,
                       NULL,
                       NULL,
                       NULL);
      
      fprintf(stderr, "Switching [incr tsdb()] in/output to UTF-8.\n"); 
    }

  } else { 
    fprintf(stderr, "SP_CTYPE is not set. [incr tsdb()] in/output remains 8BIT\n");
  }

  /* This is the default!
  SP_set_wcx_hooks(WCX_OS_8BIT,
                   NULL,
                   NULL,
                   NULL,
                   NULL,
                   NULL);

  fprintf(stderr, "In/Output is 8bit.\n"); 

  */


  /* Look up create_run/6. */ 
  if (!(create = SP_predicate("create_run",6,"user"))){ 
    fprintf(stderr, "Could not find create_run/6.\n"); 
    return 1; 
  } 

  /* Look up process_item/8. */ 
  if (!(process = SP_predicate("process_item",7,"user"))){ 
    fprintf(stderr, "Could not find process_item/7.\n"); 
    return 1; 
  } 

  /* Look up complete_run/2. */
  if (!(complete = SP_predicate("complete_run",2,"user"))){ 
    fprintf(stderr, "Could not find complete_run/2.\n"); 
    return 1; 
  } 

  /* fprintf(stderr, "Ready and waiting.\n"); */

  if(!capi_register(trale_create_run,
                    trale_process_item,
                    trale_reconstruct_item,
                    trale_complete_run)){
    slave();
  } /* if */


  return 0;

}



