%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%   $RCSfile: retract_lex_desc.pl,v $
%%  $Revision: 1.2 $
%%      $Date: 2003/05/27 02:38:55 $
%%     Author: Stefan Mueller (Stefan.Mueller@uni-bremen.de)
%%    Purpose: Code to retract stems after loading a grammar.
%%             Stems cannot be used in actual analyses. The
%%             lexicon is computed before parsing. But during
%%             parsing zero inflected and not yet inflected items
%%             are considered, which slows things down.
%%
%%   Language: Prolog
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% $Log: retract_lex_desc.pl,v $
%% Revision 1.2  2003/05/27 02:38:55  dm
%% Changed lex/3 to lex/2 as is now defined in ale.pl
%%
%% Revision 1.1  2003/05/08 21:50:58  stefan
%% *** empty log message ***
%%
%%
%% Revision 1.1  2003/04/19 11:22:37  stefan
%% Initial revision
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




retract_lex_desc(Desc) :-
  call_residue((clause(lex(Word,FS),true,Ref),
		deref(FS,Tag,SVs),
                (secret_noadderrs
                ; secret_adderrs,
                  fail),
                add_to(Desc,Tag-SVs),
                deref(Tag,SVs,TagOut,SVsOut),
                extensionalise(TagOut,SVsOut),
                (secret_adderrs
                ; secret_noadderrs,
                  fail)),_Residue),
write(user_error,'Retracting '),write(user_error,Word),nl(user_error),
  erase(Ref),
  fail.
              
retract_lex_desc(_).
